# -*- coding: utf-8 -*-

from optparse import OptionParser
import traceback

from shtools.utils.cmdline import CmdLine
from shtools.utils.log import Logger

logger = Logger("SHTools")


class Bash(object):
    def __init__(self, cmdline=""):
        self.logger = logger
        self.parser = self.get_parser()
        self.options, self.args = self.parse_args(self.cmdlineparse(cmdline))

    def cmdlineparse(self, cmdline):
        return CmdLine.to_list(cmdline)
    
    def print_help(self):
        self.parser.print_help()

    def get_parser(self):
        return OptionParser()

    def parse_args(self, args):
        return self.parser.parse_args(args)

    def optparse(self, args):
        raise NotImplementedError("Bash.optparse")

    def run(self):
        try:
            return self._run()
        except Exception as err:
            self.logger.warn(traceback.format_exc())
            return "", repr(err), 255

    def _run(self):
        raise NotImplementedError("Bash.run")
